×
INTELLIGENT WORK FORUMS
FOR ENGINEERING PROFESSIONALS

Contact US

Log In

Come Join Us!

Are you an
Engineering professional?
Join Eng-Tips Forums!
  • Talk With Other Members
  • Be Notified Of Responses
    To Your Posts
  • Keyword Search
  • One-Click Access To Your
    Favorite Forums
  • Automated Signatures
    On Your Posts
  • Best Of All, It's Free!

*Eng-Tips's functionality depends on members receiving e-mail. By joining you are opting in to receive e-mail.

Posting Guidelines

Promoting, selling, recruiting, coursework and thesis posting is forbidden.

Students Click Here

Add material

Add material

Add material

(OP)
Hello,

I am creating a macro, which add material to part, read mass and put it to lblMassValue. Button2 add material to Body but weight is not updated, it stays the same as it was without material.

CODE -->

Public Class Form1

    Public MyActiveDocument As Document
    Public MyProduct As Product
    Public MyParamMass As Double
    Public MyPart As Part

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        MyActiveDocument = GetCATIA.ActiveDocument
        MyProduct = MyActiveDocument.product
        GetCATIA()
    End Sub

    Public Function GetCATIA() As INFITF.Application
        Try
            GetCATIA = GetObject(, "CATIA.Application")
            lblMasaValue.Text = MyParamMass
        Catch NoCATIARunning As Exception
            GetCATIA = CreateObject("CATIA.Application")
        End Try

    End Function

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        Dim CATMatManager As MaterialManager
        Dim MaterialDocPath As String
        Dim MaterialName, MaterialFamilyName As String
        Dim MaterialDocument As Document
        Dim MyMaterial As Material
        Dim MyBody As Body
        Dim LinkMode
        Dim anlysisMaterial As MaterialManager

        MyParamMass = FormatNumber(MyProduct.Analyze.Mass, 2)
        MyPart = GetCATIA.ActiveDocument.Part

        '*************Identify Material ******************
            MaterialName = "Oak"
            MaterialFamilyName = "Wood"

        ' *************Identify the Material Doc Path: *******************
        MaterialDocPath = "C:\Program Files\Dassault Systemes\B27\win_b64\startup\materials\Catalog.CATMaterial" '*

        '**************Modified From the AutomationV5.chm File:
        MaterialDocument = GetCATIA.Documents.Read(MaterialDocPath)
        MyMaterial = MaterialDocument.Families.Item(MaterialFamilyName).Materials.Item(MaterialName)
        CATMatManager = MyPart.GetItem("CATMatManagerVBExt")

        MyBody = MyPart.MainBody

        ' -----------------------------------------------------------
        ' Apply the material on the Product (as a link)
        ' -----------------------------------------------------------
        LinkMode = 1
        CATMatManager.ApplyMaterialOnBody(MyBody, MyMaterial, LinkMode)

        ' -----------------------------------------------------------
        ' Retrieve the material applied on the Product
        ' -----------------------------------------------------------

        MyPart.Update()
        lblMassValue.Update()
        lblMassValue.Text = MyParamMass

    End Sub
End Class 

RE: Add material

(OP)
Hi LucasC

Thank's for response, finaly I found mistake in my code. I only added Call and it works.

CODE -->

Public Class Form1

    Public MyActiveDocument As Document
    Public MyProduct As Product
    Public MyParamMass As Double
    Public MyPart As Part

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        MyActiveDocument = GetCATIA.ActiveDocument
        MyProduct = MyActiveDocument.product
        GetCATIA()
    End Sub

    Public Function GetCATIA() As INFITF.Application
        Try
            GetCATIA = GetObject(, "CATIA.Application")
            lblMasaValue.Text = MyParamMass
        Catch NoCATIARunning As Exception
            GetCATIA = CreateObject("CATIA.Application")
        End Try

    End Function

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        Dim CATMatManager As MaterialManager
        Dim MaterialDocPath As String
        Dim MaterialName, MaterialFamilyName As String
        Dim MaterialDocument As Document
        Dim MyMaterial As Material
        Dim MyBody As Body
        Dim LinkMode
        Dim anlysisMaterial As MaterialManager

        MyParamMass = FormatNumber(MyProduct.Analyze.Mass, 2)
        MyPart = GetCATIA.ActiveDocument.Part

        '*************Identify Material ******************
            MaterialName = "Oak"
            MaterialFamilyName = "Wood"

        ' *************Identify the Material Doc Path: *******************
        MaterialDocPath = "C:\Program Files\Dassault Systemes\B27\win_b64\startup\materials\Catalog.CATMaterial" '*

        '**************Modified From the AutomationV5.chm File:
        MaterialDocument = GetCATIA.Documents.Read(MaterialDocPath)
        MyMaterial = MaterialDocument.Families.Item(MaterialFamilyName).Materials.Item(MaterialName)
        CATMatManager = MyPart.GetItem("CATMatManagerVBExt")

        MyBody = MyPart.MainBody

        ' -----------------------------------------------------------
        ' Apply the material on the Product (as a link)
        ' -----------------------------------------------------------
        LinkMode = 1
        CATMatManager.ApplyMaterialOnBody(MyBody, MyMaterial, LinkMode)

        ' -----------------------------------------------------------
        ' Retrieve the material applied on the Product
        ' -----------------------------------------------------------

        MyPart.Update()

Call ShowMass()

    End Sub

    Sub ShowMass()
        MyParamMass = FormatNumber(MyProduct.Analyze.Mass, 2)
        lblMasaValue.Text = MyParamMass
    End Sub

End Class 

Red Flag This Post

Please let us know here why this post is inappropriate. Reasons such as off-topic, duplicates, flames, illegal, vulgar, or students posting their homework.

Red Flag Submitted

Thank you for helping keep Eng-Tips Forums free from inappropriate posts.
The Eng-Tips staff will check this out and take appropriate action.

Reply To This Thread

Posting in the Eng-Tips forums is a member-only feature.

Click Here to join Eng-Tips and talk with other members! Already a Member? Login


Resources

Low-Volume Rapid Injection Molding With 3D Printed Molds
Learn methods and guidelines for using stereolithography (SLA) 3D printed molds in the injection molding process to lower costs and lead time. Discover how this hybrid manufacturing process enables on-demand mold fabrication to quickly produce small batches of thermoplastic parts. Download Now
Design for Additive Manufacturing (DfAM)
Examine how the principles of DfAM upend many of the long-standing rules around manufacturability - allowing engineers and designers to place a part’s function at the center of their design considerations. Download Now
Taking Control of Engineering Documents
This ebook covers tips for creating and managing workflows, security best practices and protection of intellectual property, Cloud vs. on-premise software solutions, CAD file management, compliance, and more. Download Now

Close Box

Join Eng-Tips® Today!

Join your peers on the Internet's largest technical engineering professional community.
It's easy to join and it's free.

Here's Why Members Love Eng-Tips Forums:

Register now while it's still free!

Already a member? Close this window and log in.

Join Us             Close